/*
	(Using the output from BLASTALL...)

	bitscore -- reduce a byte score matrix down to a bit score matrix
	using a cutoff value to determine which scores should be TRUE and
	which should be FALSE.

	The first byte output by this program is the cutoff score that was used.
	Every byte score greater than OR EQUAL to the cutoff is set to TRUE
	in the output.
*/
#include <ncbi.h>


main(ac, av)
	int	ac;
	char	**av;
{
	int		cutoff = 40;
	register int		c;
	register int		cnt = 0;
	register unsigned char	bscore = 0;
	register int	rcutoff; /* register version of cutoff */

	if (ac > 1)
		if (sscanf(av[1], "%d", &cutoff) != 1) {
			fprintf(stderr, "Invalid cutoff score:  %s\n", av[1]);
			exit(1);
		}

	rcutoff = cutoff;
	putchar(rcutoff);

	while ((c = getchar()) != EOF) {
		bscore >>= 1;
		if (c >= rcutoff)
			bscore |= 0x80;
		if (++cnt == 8) {
			putchar(bscore);
			cnt = 0;
		}
	}
	if (cnt > 0) {
		bscore >>= (8-cnt);
		putchar(bscore);
	}
}
