/* UNIX-specific input routine; database must be processed by SETDB */

static void
initdb(dbname)
	char	*dbname;
{
	Int4	dbformat;
	char	*dirname = CWDSTR;
	char	database[FILENAME_MAX];
	char	name[FILENAME_MAX];
	long	many, len;
	int		once=0;

	current = -1;

RETRY:
	if (*dirname != NULLB)
		(void) sprintf(database, "%s%c%s", dirname, DIRDELIMCHR, dbname);
	else
		STRNCPY(database, dbname, sizeof(database));

	(void) sprintf(name, "%s.tab", database);
	tfile = fopen(name, "r");
	if (tfile == NULL) {
		if ((dirname = getenv("BLASTP")) == NULL)
			dirname = BLASTP_DIR;
		if (++once == 1)
			goto RETRY;
		fatal("couldn't open database file ``%s''", name);
	}
	if (fread((char *)&dbformat, sizeof(dbformat), 1, tfile) != 1 ||
			dbformat != AAFORMAT)
		fatal("Database format is an incompatible version");
	if (fread((char *)&nbr_seqs, sizeof(nbr_seqs), 1, tfile) != 1 ||
			fread((char *)&maxlen, sizeof(maxlen), 1, tfile) != 1)
		fatal("corrupted database file:  %s", name);
	many = nbr_seqs + 1;
	ss_seq = ckalloc(sizeof(*ss_seq)*(maxlen+1));
	seq_beg = (off_t *)ckalloc(sizeof(*seq_beg)*many);
	header_beg = (off_t *)ckalloc(sizeof(*header_beg)*many);

	if (fread((char *)seq_beg, sizeof(*seq_beg), many, tfile) != many)
		fatal("improper sequence offsets in database");
	if (fread((char *)header_beg, sizeof(*header_beg), many, tfile) != many)
		fatal("improper header offsets in database");
	(void) fclose(tfile);

	(void) sprintf(name, "%s.head", database);
	hfile = ckopen(name, "r");

	(void) sprintf(name, "%s.bseq", database);
#ifdef USE_SHM
	/* Attach a shared memory segment for the .bseq file (if one exists) */
	if ((dbbuf = shm_attfile(name, "r")) == NULL)
#endif /* USE_SHM */
	{
		sfile = fopen(name, "r");
		if (sfile == NULL)
			fatal("Couldn't open database file %s", name);
		(void) fseek(sfile, (long)seq_beg[0], 0);
#ifndef BLAST3
		s_seq = ckalloc(sizeof(*s_seq)*(maxlen+2));
#else
		dbsize = sys_filesize(name);
		s_seq = ckalloc(sizeof(*s_seq)*dbsize);
		(void) printf("Reading database into memory...\n");
		(void) fflush(stdout);
		if (fread((char *)s_seq, (int)dbsize, 1, sfile) != 1)
			fatal("Database read error");
#endif
		*s_seq++ = NULLB;
	}

	len = maxlen + q_len + 1;
	_dlev = (DIAG_TYPE *)ckalloc0(sizeof(*_dlev)*len);
	diag_level = _dlev + q_len;
	diag_top = diag_stack = (int *)ckalloc(sizeof(*diag_top)*len);

	/* account for null terminator bytes */
	totdblen = seq_beg[nbr_seqs] - seq_beg[0] - nbr_seqs;

	if (Neff == 0)
		Neff = totdblen;

	fclose(tfile);
}
