#define NUCID_MIN	0
#define NUCID_MAX	15
#define NUCID_CNT	16

#define NA (NUCID_MAX+1)	/* Not A residue */
#define EL (NA+1)		/* End of Line */
#define ES (NA+2)		/* End of Sequence */


/*********************************************
*
*  ASCII-to-binary and binary-to-ASCII
*  translation tables
*
*********************************************/

EXTERN int nt_atob[128]
#ifdef INIT
	= {
	EL,NA,NA,NA,NA,NA,NA,NA,NA,NA,EL,NA,NA,EL,NA,NA,
	NA,NA,NA,NA,NA,NA,NA,NA,NA,NA,NA,NA,NA,NA,NA,NA,
	NA,NA,NA,NA,NA,NA,NA,NA,NA,NA,ES,NA,NA,NA,NA,NA,
	NA,NA,NA,NA,NA,NA,NA,NA,NA,NA,NA,NA,NA,NA,NA,NA,
	ES, 0,10, 1,11,NA,NA, 2,12,NA,NA, 7,NA, 6,14,NA,
	 4, 5, 4, 9, 3, 3,13, 8,15, 5,NA,NA,NA,NA,NA,NA,
	ES, 0,10, 1,11,NA,NA, 2,12,NA,NA, 7,NA, 6,14,NA,
	 4, 5, 4, 9, 3, 3,13, 8,15, 5,NA,NA,NA,NA,NA,NA
	}
#endif
	;

EXTERN char	nt_btoa[ES+2]
#ifdef INIT
	= "ACGTRYMKWSBDHVNX???"
#endif
	;



/*********************************************
*
*  Reverse complement tables
*
*********************************************/

EXTERN char nt_brevcomp[128] /* binary-to-binary reverse complement */
#ifdef INIT
	= {
		 3, 2, 1, 0, 5, 4, 7, 6, 8, 9,13,12,11,10,14,15,
		16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,
		16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,
		16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,
		16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,
		16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,
		16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,
		16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16
	}
#endif
	;

EXTERN char nt_arevcomp[128] /* ASCII-to-ASCII reverse complement */
#ifdef INIT
#define NAN	'?' /* Not A Nucleotide, used when rev. complement is undefined */
	= {
        NAN,NAN,NAN,NAN,NAN,NAN,NAN,NAN,
        NAN,NAN,NAN,NAN,NAN,NAN,NAN,NAN,
        NAN,NAN,NAN,NAN,NAN,NAN,NAN,NAN,
        NAN,NAN,NAN,NAN,NAN,NAN,NAN,NAN,
        NAN,NAN,NAN,NAN,NAN,NAN,NAN,NAN,
        NAN,NAN,NAN,NAN,NAN,NAN,NAN,NAN,
        NAN,NAN,NAN,NAN,NAN,NAN,NAN,NAN,
        NAN,NAN,NAN,NAN,NAN,NAN,NAN,NAN,
    /*   @   A   B   C   D   E   F   G  */
        NAN,'T','V','G','H',NAN,NAN,'C',
    /*   H   I   J   K   L   M   N   O  */
        'D',NAN,NAN,'M',NAN,'K','N',NAN,
    /*   P   Q   R   S   T   U   V   W  */
        'Y','R','Y','S','A','A','B','W',
    /*   X   Y   Z                      */
        'X','R',NAN,NAN,NAN,NAN,NAN,NAN,
    /*   `   a   b   c   d   e   f   g  */
        NAN,'T','V','G','H',NAN,NAN,'C',
    /*   h   i   j   k   l   m   n   o  */
        'D',NAN,NAN,'M',NAN,'K','N',NAN,
    /*   p   q   r   s   t   u   v   w  */
        'Y','R','Y','S','A','A','B','W',
    /*   x   y   z                      */
        'X','R',NAN,NAN,NAN,NAN,NAN,NAN,
        }
#undef NAN
#endif
        ;

EXTERN Degen	nt_adegen[16] /* ASCII degeneracy table */
#ifdef INIT
		= {
	'A',	1,	"A",
	'C',	1,	"C",
	'G',	1,	"G",
	'T',	1,	"T",
	'R',	2,	"AG",
	'Y',	2,	"CT",
	'M',	2,	"AC",
	'K',	2,	"GT",
	'W',	2,	"AT",
	'S',	2,	"CG",
	'B',	3,	"CGT",
	'D',	3,	"AGT",
	'H',	3,	"ACT",
	'V',	3,	"ACG",
	'N',	4,	"ACGT",
	'X',	1,	"X"
	}
#endif
	;

EXTERN Degen	nt_bdegen[16] /* binary degeneracy table */
#ifdef INIT
		= {
	'\000',	1,	"\000",
	'\001',	1,	"\001",
	'\002',	1,	"\002",
	'\003',	1,	"\003",
	'\004',	2,	"\000\002",
	'\005',	2,	"\001\003",
	'\006',	2,	"\000\001",
	'\007',	2,	"\002\003",
	'\010',	2,	"\000\003",
	'\011',	2,	"\001\002",
	'\012',	3,	"\001\002\003",
	'\013',	3,	"\000\002\003",
	'\014',	3,	"\000\001\003",
	'\015',	3,	"\000\001\002",
	'\016',	4,	"\000\001\002\003",
	'\017',	1,	"\017"
	}
#endif
	;


/* Generate an appropriate random BINARY nucleotide from the list ACGT */
#define RANDOM_BNUC(c)	(c < nt_atob['X'] ? \
	nt_bdegen[c].list[(rnd_gen()>>8)%nt_bdegen[c].ndegen] \
	: ((rnd_gen()>>8) % 4) )

/* Generate an appropriate random ASCII nucleotide from the list ACGT */
#define RANDOM_ANUC(c)	(nt_atob[c] < nt_atob['X'] ? \
	nt_adegen[nt_atob[c]].list[(rnd_gen()>>8)%nt_adegen[nt_atob[c]].ndegen] \
	: nt_btoa[((rnd_gen()>>8) % 4)] )

#undef NA
#undef EL
#undef ES
