#include <ncbi.h>
#define TBLASTN
#include "blast.h"

/*-------------------------  ovlap_t()---------------------------------

	ovlap_t(hp1, hp2)

	return TRUE if hp1 and hp2 overlap; otherwise return FALSE.
*/
Boolean
ovlap_t(hp1, hp2)
	struct hsp far	*hp1;
	register struct hsp far	*hp2;
{
	register Int4	q_pos, s_pos, len;

	if (hp1->frame != hp2->frame)
		return FALSE;

	q_pos = hp1->q_pos;
	s_pos = hp1->s_pos;
	len = hp1->len;
			/* hp1 contains hp2? */
	if ((q_pos <= hp2->q_pos && q_pos + len >= hp2->q_pos + hp2->len) ||
			/* hp2 contains hp1? */
			(q_pos >= hp2->q_pos && q_pos + len <= hp2->q_pos + hp2->len) ||
			/* hp1 contains hp2? */
			(s_pos <= hp2->s_pos && s_pos + len >= hp2->s_pos + hp2->len) ||
			/* hp2 contains hp1? */
			(s_pos >= hp2->s_pos && s_pos + len <= hp2->s_pos + hp2->len))
		return TRUE;
	return FALSE;
}
