/*
	pamscore

	Read in the PAM120 file, then read two lines of equal-length sequence
	from standard input and report their PAM score on standard output.

	Usage:  pamscore [pamfile]

*/
#include <ncbi.h>

char	*strtok();

int		pam[128][128];
char	letters[128], revtab[128];
int		nletters;

char	seq1[256], seq2[256];

char	*fname = "PAM120";

main(ac, av)
	int		ac;
	char	**av;
{
	FILE	*fp;
	char	buf[133], *cp, *cp2;
	register int	i, j;

	if (ac > 1)
		fname = av[1];

	fp = fopen(fname, "r");
	if (fp == NULL) {
		fprintf(stderr, "Couldn't open PAM file:  %s\n", fname);
		exit(1);
	}

	fgets(buf, sizeof(buf), fp);
	cp = strtok(buf, " \t\n");
	while (cp != NULL) {
		revtab[*cp] = nletters;
		letters[nletters++] = *cp;
		cp = strtok(NULL, " \t\n");
	}

	for (i=0; i<nletters; ++i)
		for (j=0; j<nletters; ++j)
			if (fscanf(fp, "%d", &pam[letters[i]][letters[j]]) != 1) {
				fprintf(stderr, "numeric conversion error\n");
				exit(2);
			}

	if (fgets(seq1, sizeof seq1, stdin) == NULL)
		exit(3);
	if (fgets(seq2, sizeof seq2, stdin) == NULL)
		exit(3);

	i = strlen(seq1);
	j = strlen(seq2);
	if (i < 2 || j < 2)
		exit(3);
	seq1[i-1] = NULLB;
	seq2[j-1] = NULLB;

	STRTOUPPER(seq1);
	STRTOUPPER(seq2);

	i = 0;
	for (cp = seq1, cp2 = seq2; *cp != NULL && *cp2 != NULL; ++cp, ++cp2) {
		j = pam[*cp][*cp2];
		if (j > 0)
			putchar('+');
		if (j == 0)
			putchar(' ');
		if (j < 0)
			putchar('-');
		i += j;
	}
	putchar('\n');
	for (cp = seq1, cp2 = seq2; *cp != NULL && *cp2 != NULL; ++cp, ++cp2) {
		j = pam[*cp][*cp2];
		j = ABS(j)/10;
		if (j > 0)
			putchar(j+'0');
		else
			putchar(' ');
	}
	putchar('\n');
	for (cp = seq1, cp2 = seq2; *cp != NULL && *cp2 != NULL; ++cp, ++cp2) {
		j = pam[*cp][*cp2];
		j = ABS(j)%10;
		putchar(j+'0');
	}

	printf("\nScore = %d\n", i);
}
