/*
	rescount.c

	Tally the residue frequencies in a binary-encoded amino acid database
	(a la the binary database produced by SETDB for BLASTP).

	WRG
*/
#include <ncbi.h>
#define EXTERN
#define BLASTP
#include "aabet.h"

int	freq[256];
double	prob[256];

main()
{
	register int	ch;
	int		i, j, end, tot;
	double	xtot;

	while ((ch = getchar()) != EOF)
		++freq[ch];

	for (end=255; end>0; --end)
		if (freq[end] != 0)
			break;

	tot = 0;
	for (i=1; i<=end; ++i)
		tot += freq[i];
	xtot = tot;

	for (i=1; i<=end; ++i) {
		prob[i] = freq[i] / xtot;
		printf("%c. %7d %#0.4lg\n", aa_btoa[i], freq[i], prob[i]);
	}
}
